#include <pspkernel.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
// ėp֐u}N
#define printf pspDebugScreenPrintf
#define locate pspDebugScreenSetXY
#define cls pspDebugScreenClear

PSP_MODULE_INFO("threenine", 0, 1, 1);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);
// HOME{^Ŗ߂ʂ\u͂vIԂƏIB
int exit_callback(int arg1, int arg2, void *common)
{
	sceKernelExitGame(); return 0;
}
int CallbackThread(SceSize args, void *argp)
{
	int cbid = sceKernelCreateCallback
					("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);
	sceKernelSleepThreadCB(); return 0;
}
int SetupCallbacks(void)
{
	int thid = sceKernelCreateThread
				("update_thread", CallbackThread,0x11, 0xFA0, 0, 0);
	if(thid >= 0) sceKernelStartThread(thid, 0, 0);
	return thid;
}
// ֐vg^Cv錾
void Title();
void InitParam();
int ScrollStage(); // Q[I[o[̂intŕԂl
void DrawStage();
void GetAndPut();
void GameOver();
// O[oϐ錾
SceCtrlData pad,padBefore;
static char m_cStageMap[8][30];
int m_iShip_y,m_iFrameCount,m_iScrollWait,m_iStockParam,m_iScore=0;

// ȉC[`
int main(int argc, char *argv[])
{
	pspDebugScreenInit();
	SetupCallbacks(); // R[obN`
	sceCtrlSetSamplingCycle(0); // pbhݒ
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	// ^CgʁR[
	Title(); InitParam();
	// ȉC[v
	while(1){
		// EFCgJEgXN[
		m_iFrameCount++;
		if(m_iFrameCount>m_iScrollWait){
			m_iFrameCount=0;
			if(ScrollStage()==-1) GameOver();
			// XN[ƂɃXs[hAbv
			if(m_iScrollWait>60) m_iScrollWait--;
		}
		sceCtrlReadBufferPositive(&pad, 1);
		// ㉺{^Ŏ@ړ(čWύX)
		if((pad.Buttons & PSP_CTRL_UP) 
			&& padBefore.Buttons==0 && m_iShip_y!=0){
			locate(1,m_iShip_y+3); printf("  "); m_iShip_y--;
		}
		if((pad.Buttons & PSP_CTRL_DOWN) 
		&& padBefore.Buttons==0 && m_iShip_y!=7){
			locate(1,m_iShip_y+3); printf("  "); m_iShip_y++;
		}
		// {^GetAndPut()R[
		if((pad.Buttons & PSP_CTRL_CIRCLE) && padBefore.Buttons==0)
			GetAndPut();
		// L{^狭XN[
		if((pad.Buttons & PSP_CTRL_LTRIGGER) && padBefore.Buttons==0){
			if(ScrollStage()==-1) GameOver();
		}
		padBefore = pad; // pbhҔ
		DrawStage(); // Xe[W`
		sceDisplayWaitVblankStart(); // [v
	}
	return 0;
}

// ^Cg
void Title(){
	locate(2 ,2); printf("+----------------------------+");
	locate(2 ,3); printf("|         three-nine         |");
	locate(2 ,4); printf("|     PUSH START BUTTON      |");
	locate(2 ,5); printf("+----------------------------+");
	while(!(pad.Buttons & PSP_CTRL_START))
		sceCtrlReadBufferPositive(&pad, 1);
}

// ϐʂ̏
void InitParam(){
	int i=0;
	// ϐ
	m_iShip_y = 3; m_iFrameCount = 0; m_iScrollWait = 360;
	m_iStockParam = 0; m_iScore=0;
	// 
	srand((unsigned)time(NULL));
	// Xe[W͖[Ƀ_l
	memset(m_cStageMap,0,sizeof(m_cStageMap));
	for(i=0;i<=7;i++) m_cStageMap[i][27]=rand()%5+1;
	// Xe[Wg`
	cls();
	locate(2 ,2 ); printf("+----------------------------+");
	for(i=0;i<=7;i++){ locate(31,i+3); printf("|"); }
	locate(2 ,11); printf("+----------------------------+");
}

// XN[Q[I[o[
int ScrollStage(){
	int x=0,y=0;
	// ɔzVtgI[Ƀ_l
	for(y=0;y<=7;y++){
		// XN[Om_cStageMap[y][0]0łȂGAME OVER
		if(m_cStageMap[y][0]!=0) return -1;
		// vȂXN[
		for(x=0;x<=26;x++){
			m_cStageMap[y][x] = m_cStageMap[y][x+1];
		}
		m_cStageMap[y][27]=rand()%5+1;
	}
	return 0;
}

// Xe[W⎩@`
void DrawStage(){
	char temp[29];
	int x=0,y=0;
	// XRA`
	locate(0,0); printf("Score : %08d ",m_iScore);
	// Xe[W`
	for(y=0;y<=7;y++){
		memcpy(temp,m_cStageMap[y],28);
		for(x=0;x<=27;x++){
			// Xe[W0̓Xy[XAȊO͐ɒu
			// @̑Oɂ0"="̃}[J[zu
			if(temp[x]==0){
				if(y==m_iShip_y) temp[x]='='; else temp[x]=' ';
			}else temp[x]+='0'; // +='0'ASCIIϊ
		}
		temp[28]='\0';
		locate(3,y+3); printf("%s",temp);
	}
	// @`
	locate(1,m_iShip_y+3);
	if(m_iStockParam==0) printf("(#"); else printf("(%d",m_iStockParam);
}

// 擾ˏo
void GetAndPut(){
	int i=0;
	// ێp[^0̂Ƃ͎擾ցB
	if(m_iStockParam==0){
		for(i=0;i<=26;i++) if(m_cStageMap[m_iShip_y][i]) break;
		m_iStockParam = (int)m_cStageMap[m_iShip_y][i];
		m_cStageMap[m_iShip_y][i]=0;
	}else{ // ˏo[`BOɐlmOɐݒu
		for(i=0;i<=26;i++) if(m_cStageMap[m_iShip_y][i+1]) break;
		m_cStageMap[m_iShip_y][i] = (char)m_iStockParam;
		m_iStockParam=0;
		// ݒuɂ̑Oɑ΂ČvZBvl9ȂXRAZB
		if(m_cStageMap[m_iShip_y][i] + m_cStageMap[m_iShip_y][i+1] +
			m_cStageMap[m_iShip_y][i+2] == 9){
			m_cStageMap[m_iShip_y][i]=0; m_cStageMap[m_iShip_y][i+1]=0;
			m_cStageMap[m_iShip_y][i+2]=0; m_iScore++;
		}
	}
}

// Q[I[o[
void GameOver(){
	int x=0,y=0;
	for(y=0;y<=7;y++){
		for(x=0;x<=28;x++){
			locate(x+2,y+3); printf("*");
		}
	}
	locate(9,5); printf(" - GAME OVER - ");
	locate(8,7); printf("PUSH START BUTTON");
	while(!(pad.Buttons & PSP_CTRL_START))
		sceCtrlReadBufferPositive(&pad, 1);
	InitParam(); // ϐă^[
}